/**
 * The class represents the base class for geometric objects.
 * 
 * @author <a href="mailto:Thomas.Roefer@dfki.de">Thomas R&ouml;fer</a>
 * @author <a href="mailto:b21@informatik.uni-bremen.de">Oliver B&ouml;sche</a>
 * @author <a href="mailto:raider@informatik.uni-bremen.de">Thiemo Wiedemeyer</a>
 */
class Geometry extends Node
{
    /**
     * The constructor.
     * 
     * @param name The objects identifier name.
     * @param parent The reference to the parent object.
     */
    Geometry(String name, Node parent) {
        super(name, parent);
    }

    /**
     * The raw method to generate a bounding begin.
     * 
     * @param code The code output stream.
     */
    public void generateCodeBoundingStart(TreeStream code) {
        generateCodeBoundingStart(code, true);
    }

    /**
     * The raw method to generate a bounding begin as a simple physical or normal object.
     * 
     * @param code The code output stream.
     * @param simple Is it a simple physical object?
     */
    public void generateCodeBoundingStart(TreeStream code, boolean simple) {
    }

    /**
     * The raw method to generate a bounding closure.
     * 
     * @param code The code output stream.
     * @param simple Is it a simple physical object?
     */
    public void generateCodeBoundingEnd(TreeStream code, boolean simple) {
    }

    /**
     * The raw method to generate a geometric object with an optional tranformation.
     * 
     * @param code The code output stream.
     * @param t The transformation.
     */
    public void generateCode(TreeStream code, Transform t) {
    }
}
