/**
 * The class represents an identifier in the source code.
 * 
 * @author <a href="mailto:Thomas.Roefer@dfki.de">Thomas R&ouml;fer</a>
 * @author <a href="mailto:b21@informatik.uni-bremen.de">Oliver B&ouml;sche</a>
 * @author <a href="mailto:raider@informatik.uni-bremen.de">Thiemo Wiedemeyer</a>
 */
class Identifier {
    /** The name of the identifier. */
    String name;

    /** The positon in the source code the identifier was read. */
    Position position;

    /**
     * The constructor.
     * @param name The name of the identifier.
     * @param position The position in the source code the identifier was read.
     */
    Identifier(String name, Position position) {
        this.name = name;
        this.position = position;
    }
}
