/**
 * The class represents an image texture. 
 *
 * @author <a href="mailto:Thomas.Roefer@dfki.de">Thomas R&ouml;fer</a>
 * @author <a href="mailto:b21@informatik.uni-bremen.de">Oliver B&ouml;sche</a>
 * @author <a href="mailto:raider@informatik.uni-bremen.de">Thiemo Wiedemeyer</a>
 */
class ImageTexture extends Node
{
    /** The location of the image. */
    String url;

    /**
     * The contructor.
     * 
     * @param name The texture identifier name.
     * @param parent The reference to the parent object.
     */
    ImageTexture(String name, Node parent) {
        super(name, parent);
    }

    /**
     * The method generates the texture code.
     * 
     * @param code The code output stream.
     */
    public void generateCode(TreeStream code) {
        code.indent();
        if(url != null)
            code.println("<DiffuseTexture file=\"Textures/" + url.replace(".png", ".tga") + "\" mode=\"GL_MODULATE\" />");
        code.unindent();
    }
}
