/**
 * The class Vector3D is just another implementation of a 3-D vector.
 * Only the methods that are actually used by other classes are implemented.
 * These methods were basically copied from SimRobot's class Vector3d.
 * 
 * @author <a href="mailto:Thomas.Roefer@dfki.de">Thomas R&ouml;fer</a>
 */
class Vector3D implements Cloneable {
    /** The three components of the vector. */
    double v[] = new double[3];
    
    /** The implementation of the interface Cloneable. */
    public Object clone() {
        Vector3D vec = new Vector3D();
        vec.v[0] = v[0];
        vec.v[1] = v[1];
        vec.v[2] = v[2];
        return vec;
    }
    
    /** 
     * The method adds this vector and another vector.
     * @param vec The other vector.
     * @return The sum of the two vectors.
     */
    Vector3D add(Vector3D vec) {
        Vector3D newVec = new Vector3D();
        newVec.v[0] = v[0] + vec.v[0];
        newVec.v[1] = v[1] + vec.v[1];
        newVec.v[2] = v[2] + vec.v[2];
        return newVec;
    }
    
    /** 
     * The method multiplies this vector with a scalar value.
     * @param vec The scalar value.
     * @return The result of the multiplication.
     */
    Vector3D mult(double d) {
        Vector3D newVec = new Vector3D();
        newVec.v[0] = v[0] * d;
        newVec.v[1] = v[1] * d;
        newVec.v[2] = v[2] * d;
        return newVec;
    }
}
