#pragma once

#include "../src/tools/asserts.h"

#if 0
#define COROUTINE_BEGIN() \
  static int _bsinternal_state = 0; \
  switch(_bsinternal_state) \
  { \
    case 0:

#define COROUTINE_END() \
  } \
  _bsinternal_state = 0; \
  return /*0*/

#define YIELD(x) \
  _bsinternal_state = __LINE__; \
  return /*x*/; \
  case __LINE__:
#endif

#if 1
#define COROUTINE_BEGIN(x) \
  ASSERT(_context->taskContextMap.find(typeid(_bstc_##x).name()) != _context->taskContextMap.end()); \
  TaskWrapperBase *_taskWrapper = (TaskWrapperBase*)(_context->taskContextMap[typeid(_bstc_##x).name()]); \
  _bstc_##x *_taskContext = (_bstc_##x*)_taskWrapper->getContextPointer(); \
  if(_context->frameID - _taskWrapper->lastExecution > 1 || _taskWrapper->state <= ast::TaskDeclarationBase::done) \
  { \
      _taskContext->_bs_state = 0; \
      _taskWrapper->state = ast::TaskDeclarationBase::running; \
  } \
  PUSH_CALL_TREE(_context->callTree, #x); \
  _taskWrapper->lastExecution = _context->frameID; \
  switch(_taskContext->_bs_state) \
  { \
    case 0:

#define COROUTINE_END() \
  } \
  _taskContext->_bs_state = 0; \
  _taskWrapper->state = ast::TaskDeclarationBase::done; \
  POP_CALL_TREE(_context->callTree); \
  return /*0*/

#define YIELD(x) \
  POP_CALL_TREE(_context->callTree); \
  _taskContext->_bs_state = __LINE__; \
  _taskContext->_bs_yieldCounter++; \
  _taskWrapper->state = (ast::TaskDeclarationBase::State)(x); \
  return /*x*/; \
  case __LINE__:

//would be nice to put an assert into this define, but since it's an expression.....
#define TASK_STATE2(m, x) \
  ((TaskWrapperBase*)_context->taskContextMap[typeid(bs_##m::_bstc_##x).name()])->state

#define TASK_STATE(x) \
  ((TaskWrapperBase*)_context->taskContextMap[typeid(_bstc_##x).name()])->state

#else

#define COROUTINE_BEGIN(x) \
  static _bstc_##x _staticTaskContext; \
  _bstc_##x *_taskContext = &_staticTaskContext; \
  switch(_taskContext->_bs_state) \
  { \
    case 0:

#define COROUTINE_END() \
  } \
  _taskContext->_bs_state = 0; \
  return /*0*/

#define YIELD(x) \
  _taskContext->_bs_state = __LINE__; \
  return /*x*/; \
  case __LINE__:

#define TASK_STATE2(m, x) \
  1

#define TASK_STATE(x) \
  1

#endif

#define EMERGENCY_YIELD(id, maxLoopsPerYield, strId) \
  do \
  { \
      if(_taskContext->_bs_for##id##_lastYield != _taskContext->_bs_yieldCounter) \
      { \
          _taskContext->_bs_for##id##_itersSinceLastYield = 0; \
          _taskContext->_bs_for##id##_lastYield = _taskContext->_bs_yieldCounter; \
      } \
      if(maxLoopsPerYield - _taskContext->_bs_for##id##_itersSinceLastYield == 0) \
      { \
          _context->errorHandler("ERROR!!!!! EMERGENCY YIELD STOPS THIS LOOP!\n   %s\n", strId); \
          YIELD(ast::TaskDeclarationBase::running); \
          continue; \
      } \
  } \
  while(false)

