/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#include "ast.h"

#include "../codeGenerator/codeGeneratorInterface.h"

using namespace ast;

//statements
void StatementBlock::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void CallStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void IfStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void ForStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void AssignmentStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void YieldStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void ReturnStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void BreakStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void ContinueStatement::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

//expressions
namespace ast
{

template <>
void LiteralExpression<bool>::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

template <>
void LiteralExpression<int>::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

template <>
void LiteralExpression<float>::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

template <>
void LiteralExpression<std::string>::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

}

void CallExpression::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void IdentifierAccessExpression::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void MemberAccessExpression::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void UnaryExpression::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void BinaryExpression::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void TaskStateExpression::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

//declarations
void VariableDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void GlobalVariableDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void FunctionDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void TaskDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void ClassDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void ModuleDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void ExternModuleDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void MasterModuleDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

void EnumDeclaration::generateCode(CodeGeneratorInterface &cg)
{
    cg.generateCode(*this);
}

