/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdarg.h>

#ifdef WIN32
#include "../tools/win32snprintf.h"
#endif

#include "../parser/location.h"
#include "contextAnalysisException.h"

ContextAnalysisException::ContextAnalysisException(const Location &location, const char *format, ...)
{
    #define bufsize 512
    char buf[bufsize+1];

    va_list ap;
    va_start(ap, format);	
    vsnprintf(buf, bufsize, format, ap);
    va_end(ap);

    msg = location.toString() + buf;
}

ContextAnalysisException::~ContextAnalysisException() throw()
{}

const char* ContextAnalysisException::what() const throw()
{
    return msg.c_str();
}
