/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <vector>

#include "../declarationCollection.h"
#include "declaration.h"

namespace yy
{
    class location;
}

class CodeGeneratorInterface;

namespace ast
{

class FunctionDeclaration;
class VariableDeclaration;
class Identifier;

class ClassDeclaration : public Declaration
{
    public:
        std::vector<VariableDeclaration*> memberVariables;
        std::vector<FunctionDeclaration*> memberFunctions;

        DeclarationCollection localDeclarationCollection;

        ClassDeclaration(Identifier *ident);

        ~ClassDeclaration();

        DeclarationType getDeclarationType() { return Class; }

        virtual void createInstance(Stack2 &stack, bool callCtor = false) = 0;
        virtual void deleteInstance(Stack2 &stack) = 0;
        virtual void assign(void *d, void *s) = 0;

        virtual void contextAnalysis(DeclarationCollection &declarationCollection);
        virtual void generateCode(CodeGeneratorInterface &cg);
};

}

