/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#include "../declarationCollection.h"
#include "valueDeclaration.h"

#include "enumDeclaration.h"

using namespace ast;

EnumDeclaration::~EnumDeclaration()
{
    localDeclarationCollection.clear();

    for(size_t i = 0; i < values.size(); i++)
        delete values.at(i);
    values.clear();
}

EnumDeclaration& EnumDeclaration::value(const std::string &name, int value, const std::string &cppName)
{
    values.push_back(new ValueDeclaration<int>(new ast::Identifier(name, Location::builtInLocation, cppName), value));
    return *this;
}

void EnumDeclaration::contextAnalysis(DeclarationCollection &declarationCollection)
{
    declarationCollection.add(ident->name, this);

    declarationCollection.enter();

    for(size_t i = 0; i < values.size(); i++)
        values.at(i)->contextAnalysis(declarationCollection);

    localDeclarationCollection = declarationCollection;
    localDeclarationCollection.stripToTopLevel();

    declarationCollection.leave();
}

