/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <vector>
#include <string>

#include "declaration.h"

class DeclarationCollection;

namespace ast
{

class Identifier;
template<typename T>
class ValueDeclaration;

class EnumDeclaration : public Declaration
{
    public:

        std::vector<ValueDeclaration<int>*> values;
        DeclarationCollection localDeclarationCollection;

        EnumDeclaration(Identifier *ident)
            : Declaration(ident)
        {
            ASSERT(ident);
        }

        ~EnumDeclaration();

        EnumDeclaration& value(const std::string &name, int value, const std::string &cppName);

        virtual void contextAnalysis(DeclarationCollection &declarationCollection);
        virtual void execute(Stack2 &stack) {}
        virtual void generateCode(CodeGeneratorInterface &cg);
        virtual Declaration::DeclarationType getDeclarationType() { return Declaration::Enum; }
};

}

