/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "typeToName.h"
#include "../../identifier.h"
#include "../moduleDeclaration.h"
#include "../enumDeclaration.h"
#include "../valueDeclaration.h"

template<typename T>
ast::EnumDeclaration& registerEnum(ast::ExternModuleDeclaration *module,
                                   const std::string &name)
{
    TypeToName::registerType<T>("_master_", "int");
    ast::EnumDeclaration *decl = new ast::EnumDeclaration(new ast::Identifier(name, Location::builtInLocation));
    module->enumDeclarations.push_back(decl);
    return *decl;
}

template<typename T>
void registerConstValue(ast::ExternModuleDeclaration *module,
                        const std::string &name,
                        T value,
                        const std::string &cppName)
{
    module->valueDeclarations.push_back(new ast::ValueDeclaration<T>(new ast::Identifier(name, Location::builtInLocation, cppName), value));
}

