/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <string>

#include "../moduleDeclaration.h"
#include "../../../tools/asserts.h"
#include "../../../tools/tr1Include.h"

namespace ast
{
class ExternModuleDeclaration;
}

class ModuleCreatorBase
{
    private:
        std::string name;
    public:
        ModuleCreatorBase(const std::string &name)
          : name(name)
        {
            ASSERT(registeredCreators.find(name) == registeredCreators.end());
            registeredCreators[name] = this;
        }

        virtual ~ModuleCreatorBase()
        {
            registeredCreators.erase(name);
        }

        static std::tr1::unordered_map<std::string, ModuleCreatorBase*> registeredCreators;

        virtual ast::ExternModuleDeclaration *createModule() = 0;
};

