/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#include "typeToName.h"

#include <stdio.h>
#ifdef WIN32
#include "../../../tools/win32snprintf.h"
#endif

TypeToName::TypeToNameMap TypeToName::typeToName;

TypeToName::TypeNotRegisteredException::TypeNotRegisteredException(const std::string &msg)
  : msg(msg)
{}

TypeToName::TypeNotRegisteredException::~TypeNotRegisteredException() throw()
{}

const char* TypeToName::TypeNotRegisteredException::what() const throw()
{
    return msg.c_str();
}

const TypeToName::TypeToNameMap::mapped_type* TypeToName::getTypeInfo(const char *typeIdName)
{
    TypeToNameMap::iterator it;
    it = typeToName.find(typeIdName);
    if(it == typeToName.end())
    {
        char buf[128];
        snprintf(buf, 128, "ERROR: type '%s' is not registered", typeIdName);
        throw TypeNotRegisteredException(buf);
        return 0;
    }
    return &it->second;
}
