/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "../node.h"

class DeclarationCollection;
class CodeGeneratorInterface;
class Stack2;

namespace ast
{

class Declaration;

class Expression : public Node
{
    public:
        enum Type
        {
            FunctionCall,
            IdentifierAccess,
            Unknown,
        };
        Expression(const Location &location)
            : Node(location)
        {}

        virtual Declaration* getType() = 0;
        virtual void contextAnalysis(DeclarationCollection &declarationCollection,
                                     DeclarationCollection &memberDeclarationCollection)
        {
            contextAnalysis(declarationCollection);
        }
        virtual void contextAnalysis(DeclarationCollection &declarationCollection) = 0;
        virtual void executeCleanUp(Stack2 &stack) = 0;
        virtual bool isLValue() = 0;
        virtual bool isRValue() { return true; }
        virtual Type getExpressionType() { return Unknown; }
        virtual bool isConst() { return false; }
};

}

