/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "expression.h"

class DeclarationCollection;
class Stack2;
class CodeGeneratorInterface;

namespace ast
{

class Identifier;

class TaskStateExpression : public Expression
{
    public:
        ResolvableIdentifier *taskIdent;
        Declaration *intDeclaration;

        TaskStateExpression(ResolvableIdentifier *taskIdent);
        ~TaskStateExpression();

        Declaration* getType();
        virtual void contextAnalysis(DeclarationCollection &declarationCollection);
        virtual void execute(Stack2 &stack);
        virtual void executeCleanUp(Stack2 &stack);
        virtual bool isLValue() { return false; }
        virtual bool isRValue() { return true; }
        virtual void generateCode(CodeGeneratorInterface &cg);
};

}

