/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "../../parser/location.h"

#include "statement.h"

namespace ast
{

class YieldStatement : public Statement
{
    public:
        Location myLocation;
        Expression *stateExpr;

        YieldStatement(const Location &location, Expression *stateExpr=0)
            : Statement(myLocation),
              myLocation(location),
              stateExpr(stateExpr)
        {}
        ~YieldStatement();

        virtual void contextAnalysis(DeclarationCollection &declarationCollection);
        virtual void execute(Stack2 &stack);
        virtual void generateCode(CodeGeneratorInterface &cg);
        virtual Statement::Type getStatementType() { return Statement::Yield; }
};

}

