/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "callTree.h"
#include "tools/tr1Include.h"

typedef void (*ErrorHandler)(const char*format, ...);

struct ExecutionContext
{
    ExecutionContext(ErrorHandler errorHandler)
      : frameID(0),
        input(0),
        output(0),
        errorHandler(errorHandler)
    {}

    unsigned frameID;

    void *input;
    void *output;

    std::tr1::unordered_map<const char*, void*> taskContextMap;
    CallTreeHandler callTree;

    ErrorHandler errorHandler;
};

