/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#ifndef WIN32
#pragma GCC diagnostic ignored "-Wparentheses"
#include "bison_flex_out/location.hh"
#pragma GCC diagnostic warning "-Wparentheses"
#else
#include "bison_flex_out/location.hh"
#include "../tools/win32snprintf.h"
#endif
//TODO: as soon as g++ >= 4.5 is widely used, replace the line above with
//#pragma GCC diagnostic pop

#include <stdio.h>
#include "location.h"

Location Location::builtInLocation(-1, -1);

Location::Location(int line, int column)
    : line(-1),
      column(-1)
{}

Location::Location(const yy::location &loc, const std::string &filename)
    : line(loc.begin.line),
      column(loc.begin.column),
      filename(filename)
{}

std::string Location::toString() const
{
    if(line == -1)
        return std::string("(builtin)");

    #define BUF_SIZE 512
    char buf[BUF_SIZE];
    snprintf(buf, BUF_SIZE, "%s(%d:%d)", filename.c_str(), line, column);

    return std::string(buf);
}

