/*
b-script
Copyright (C) 2011 Thijs Jeffry de Haas

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

class FunctorStackInterface
{
    public:
        virtual void* popPtr() = 0;
        virtual void pushPtr(void*) = 0;
};

template<typename T>
class Converter
{
    public:
        static T& toReference(void *p) { return *(T*)p; }
        static const T& toConstReference(void *p) { return *(T*)p; }
};

template<typename T>
class Converter<const T&> : public Converter<T> {};

struct FunctorBase
{
    const int numOfParams;
    const bool isConst;

    FunctorBase(int numOfParams, bool isConst = false)
      : numOfParams(numOfParams),
        isConst(isConst)
    {}

    virtual const char* getTypeIdName(int i) = 0;
    virtual void call(FunctorStackInterface &stack) = 0;
};

template <typename X>
struct Functor {};

template <typename X>
struct FunctorVoid {};

#include <typeinfo>
#include "functorImpl.h"

