#include <stdio.h>

#include "../src/bsNativeModule.h"
#include "bs_io.h"

namespace bs_io
{

void printi(int i)
{
    ::printf("%d\n", i);
}

void prints(const std::string &str)
{
    ::printf("%s\n", str.c_str());
}

void printf(float i)
{
    ::printf("%f\n", i);
}

}

BS_MODULE(io,
    registerFunctionVoid(module, "printi", &bs_io::printi);
    registerFunctionVoid(module, "prints", &bs_io::prints);
    registerFunctionVoid(module, "printf", (void(*)(float))&bs_io::printf);

    registerClass<bs_io::BSTreePrinter>(module, "TreePrinter", "bs_io::BSTreePrinter")
      .funcVoid("println", &bs_io::BSTreePrinter::println)
      .funcVoid("prints", &bs_io::BSTreePrinter::prints)
      .funcVoid("printi", &bs_io::BSTreePrinter::printi)
      .funcVoid("newline", &bs_io::BSTreePrinter::newline)
      .funcVoid("indent", &bs_io::BSTreePrinter::indent)
      .funcVoid("dindent", &bs_io::BSTreePrinter::dindent)
      ;
    );

