#include <time.h>
#include <limits.h>
#include <stdlib.h>

#include "../src/bsNativeModule.h"
#include "bs_math.h"

namespace bs_math
{

float sqr(float f)
{
    return powf(f, 2);
}

float random()
{
    return rand()/float(INT_MAX);
}

float sgnf(float f)
{
    if(f > 0)
        return 1;
    if(f < 0)
        return -1;
    return 0;
}

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

BS_MODULE(math,

    registerFunction(module, "sin", (float(*)(float))&sinf, "sinf");
    registerFunction(module, "cos", (float(*)(float))&cosf, "cosf");
    registerFunction(module, "atan2", (float(*)(float))&atan2f, "atan2f");
    registerFunction(module, "sqrt", (float(*)(float))&sqrtf, "sqrtf");
    registerFunction(module, "pow", (float(*)(float))&powf, "powf");
    registerFunction(module, "sqr", &bs_math::sqr);
    registerFunction(module, "fabs", (float(*)(float))&fabs);
    registerFunction(module, "abs", (int(*)(int))&abs);
    registerFunction(module, "sgn", &bs_math::sgnf);
    registerConstValue(module, "pi", (float)M_PI, "(float)M_PI");

    srand(unsigned(time(0)));
    registerFunction(module, "random", (float(*)())&bs_math::random);

    );

}

