#include <string>

#include "bsNativeModule.h"
#include "bs_Test.h"

class Test
{
    public:
        enum Bla
        {
            blub,
            bla,
            foo,
        };
        Bla bbb;

        Test()
            : b("aa")
        {}

        std::string b;
};

class BSTest
{
    public:
        int value;
        Test t;

        BSTest()
            : value(0)
        {}

        BSTest(int value)
            : value(value)
        {}

        BSTest getInc(int i)
        {
            return BSTest(value + i);
        }

        int _unmin_()
        {
            return -value;
        }

        BSTest _plus_(const BSTest &other)
        {
            BSTest tt;
            tt.value = value + other.value;
            tt.t.b = t.b + other.t.b;
            return tt;
        }

        std::string _not_()
        {
            return std::string("grand master not-operator greets the world");
        }

        void set(int i)
        {
            value = i;
        }

        int getValue()
        {
            return value;
        }
};

class MemoryTest
{
    public:
        MemoryTest()
        {
            ptr = new char[128];
            printf("MEMTEST CTOR\n");
        }
        ~MemoryTest()
        {
            printf("MEMTEST DTOR\n");
            delete[] ptr;
        }

        char *ptr;
};

class MyString : public std::string
{
    public:
        void set(const std::string &str)
        {
            *static_cast<std::string*>(this) = str;
        }

        void print(int i) const
        {
            printf("%s\n", c_str());
        }
};

void printI(const BSTest &i)
{
    printf("%d %s\n", i.value, i.t.b.c_str());
}

class EnumTest
{
    public:
        enum Bla
        {
            bla,
            blub,
            foo,
        };

        Bla e;
};

BS_MODULE(Test,

    registerClass<MyString>(module, "mystring")
        .funcVoid("set", &MyString::set)
        .funcVoid("print", &MyString::print);

    registerClass<MemoryTest>(module, "MemTest");

    registerEnum<EnumTest::Bla>(module, "Bla")
        .value("bla", EnumTest::bla, "EnumTest::Bla::bla")
        .value("blub", EnumTest::blub, "EnumTest::Bla::blub")
        .value("foo", EnumTest::foo, "EnumTest::Bla::foo");

    registerClass<EnumTest>(module, "EnumTest")
        .var("e", &EnumTest::e);

    registerClass<Test>(module, "Testt")
        .var("b", &Test::b);

    registerClass<BSTest>(module, "Tester")
        .func("getValue", &BSTest::getValue)
        .func("getInc", &BSTest::getInc)
        .funcVoid("set", &BSTest::set)
        .func("_unmin_", &BSTest::_unmin_)
        .func("_not_", &BSTest::_not_)
        .func("_plus_", &BSTest::_plus_)
        .var("value", &BSTest::value)
        .var("t", &BSTest::t)
        ;

    registerFunctionVoid(module, "printI", &printI);

    registerClass<InputTest>(module, "InputTest", "InputTest")
        .var("f", &InputTest::f);

    );
